#ifndef __mor_stdlib_h__
#define __mor_stdlib_h__

#if !defined (__GNUC__) && !defined (__GNUG__)
#error You lose. This file can be compiled only by GNU-C compiler.
#endif

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

#ifndef __size_t_defined__
#include <mor/size_t.h>
#endif

_EXTERN (char *import (const char *, int_));
_EXTERN (int_ export (const char *, int_));
_EXTERN (int_ isonheap (void *));
_EXTERN (void obrk (void_));
_EXTERN (void *_vdup (void *, size_t));

#define chkstack(x)					\
    (__extension__ ({					\
	extern void *_ssta;				\
	void *_c;					\
	__asm __volatile ("move.l sp,%0" : "=r" (_c));	\
	_c - (x) >= _ssta;				\
    }))

#define vdup(v) _vdup (&(v), sizeof (v))

#endif
