/* System headers */
#include <mbctype.h>
#include <mor/xmbstring.h>

/* Functions */
int _xmblen (const unsigned char *ptr)
{
    /* 1 oCgڂ`FbN */
    /* NUL `FbN */
    if (ptr[0] == '\0')
	return 0;
    /* ASCIIA1 oCgA0xA0  1 */
    if (ptr[0] <= 0x7F || (ptr[0] >= 0xA0 && ptr[0] <= 0xDF))
	return 1;
    /* 0xF6`0xFF  -1 */
    if (ptr[0] >= 0xF6)
	return -1;
    /* 0x80nnA0xFnnn  2 */
    if (ptr[0] == 0x80 || ptr[0] >= 0xF0)
	return 2;

    /* 2 oCgڂ`FbN */
    if (_ismbbtrail (ptr[1]) == 0)
	return -1;

    /*  2 oCg */
    return 2;
}

/* end of file */
