#ifndef __mor_alloca_h__
#define __mor_alloca_h__

#if !defined (__GNUC__) && !defined (__GNUG__)
#error You lose. This file can be compiled only by GNU-C compiler.
#endif

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

#ifndef __alloca_h__
#include <alloca.h>
#endif

#ifndef __string_h__
#include <string.h>
#endif

#ifndef __mor_string_h__
#include <mor/string.h>
#endif

#ifndef __mor_xmbstring_h__
#include <mor/xmbstring.h>
#endif

#ifndef __size_t_defined__
#include <mor/size_t.h>
#endif

#define calloca(a,b)	({ size_t _l = (a) * (b); void *_p = alloca (_l); bzero (_p, _l); })
#define meadup(p,n)	({ size_t _n = (n); void *_p = alloca (_n); memcpy (_p, (p), _n); })
#define realloca	meadup
#define stadup(s)	({ void *_s = (s); void *_p = alloca (strlen (_s) + 1);	\
			strcpy (_p, _s); })
#define standup(s,n)	({ void *_s = (s); size_t _l = strnlen (_s, (n));	\
			void *_p = alloca (_l + 1); strnecpy (_p, _s, _l); })
#define vadup(va)	({ size_t _l = sizeof (va); void *_p = alloca (_l);	\
			memcpy (_p, &(va), _l); })
#define xmbadup(s)	({ void *_s = (s); void *_p = alloca (xmbsblen (_s) + 1);	\
			xmbscpy (_p, _s); })
#define xmbandup(s,n)	({ void *_s = (s); size_t _l = xmbsnbcnt (_s, (n));	\
			void *_p = alloca (_l + 1); xmbsnecpy (_p, _s, _l); })

#endif
